open Sys

let print_sig = function
  | Signal_default -> prerr_string "default\n"
  | Signal_ignore  -> prerr_string "ignore\n"
  | Signal_handle _ -> prerr_string "handled\n"


let set_chain = ref (fun _ -> ()) 

let sighandler f = 
  let chain = ref (fun _ -> ()) in
  (fun n -> 
    if n < 0 then chain := !set_chain else begin
      f n;
      !chain n ;
    end)

let signal_chain n f =  
  let sh = sighandler f in
  match signal n (Signal_handle sh) with
  | Signal_handle old -> 
      Printf.eprintf "Set old (same? %b)\n" (old == sh);
      set_chain := old; 
      if old != sh then sh ~-1
  | _ -> 
      Printf.eprintf "Nothing\n";
      ()


let main () =
  signal_chain sigalrm (fun n -> Printf.eprintf "Yay 1";flush stderr);
  signal_chain sigalrm (fun n -> Printf.eprintf "Yay 2";flush stderr);
  Printf.eprintf "Alarm %d\n" (Unix.alarm 5);
  Printf.eprintf "Alarm %d\n" (Unix.alarm 4);
  flush stderr;
  while '.' != (input_char stdin) do () done

let _ = main ()
